<template>
  <form @submit.prevent="submitForm">
    <h2 class="header-form">
      <p v-if="editing">
        Edit <span class="text-neutral-400">#</span>{{ invoiceForm.id }}
      </p>
      <span v-else>Create Invoice</span>
    </h2>

    <div class="fieldset-wrapper">
      <fieldset class="grid">
        <legend>Bill From</legend>
        <div
          :class="{ invalid: v$.invoiceForm.senderAddress.street.$error }"
          class="input-wrapper"
        >
          <label for="street-address">Street address</label>
          <base-input
            type="text"
            id="street-address"
            name="street-address"
            @blur="v$.invoiceForm.senderAddress.street.$touch"
            v-model.trim="invoiceForm.senderAddress.street"
          ></base-input>
        </div>
        <div class="grid grid-city-post-country">
          <div
            :class="{ invalid: v$.invoiceForm.senderAddress.city.$error }"
            class="input-wrapper city"
          >
            <label for="city">City</label>
            <base-input
              type="text"
              id="city"
              name="city"
              @blur="v$.invoiceForm.senderAddress.city.$touch"
              v-model.trim="invoiceForm.senderAddress.city"
            ></base-input>
          </div>
          <div
            :class="{ invalid: v$.invoiceForm.senderAddress.postCode.$error }"
            class="input-wrapper postcode"
          >
            <label for="post-code">Post Code</label>
            <base-input
              type="text"
              id="post-code"
              name="post-code"
              @blur="v$.invoiceForm.senderAddress.postCode.$touch"
              v-model.trim="invoiceForm.senderAddress.postCode"
            ></base-input>
          </div>
          <div
            :class="{ invalid: v$.invoiceForm.senderAddress.country.$error }"
            class="input-wrapper country"
          >
            <label for="country">Country</label>
            <base-input
              type="text"
              id="country"
              name="country"
              @blur="v$.invoiceForm.senderAddress.country.$touch"
              v-model.trim="invoiceForm.senderAddress.country"
            ></base-input>
          </div>
        </div>
      </fieldset>
      <fieldset class="grid">
        <legend>Bill To</legend>
        <div
          :class="{ invalid: v$.invoiceForm.clientName.$error }"
          class="input-wrapper"
        >
          <label for="client-name">Client's Name</label>
          <base-input
            type="text"
            id="client-name"
            name="client-name"
            @blur="v$.invoiceForm.clientName.$touch"
            v-model.trim="invoiceForm.clientName"
          ></base-input>
        </div>
        <div
          :class="{ invalid: v$.invoiceForm.clientEmail.$error }"
          class="input-wrapper"
        >
          <label for="client-email">Client's Email</label>
          <base-input
            type="email"
            placeholder="e.g. email@example.com"
            id="client-email"
            name="client-email"
            @blur="v$.invoiceForm.clientEmail.$touch"
            v-model.trim="invoiceForm.clientEmail"
          ></base-input>
        </div>
        <div
          :class="{ invalid: v$.invoiceForm.clientAddress.street.$error }"
          class="input-wrapper"
        >
          <label for="client-street-address">Street Address</label>
          <base-input
            type="text"
            id="client-street-address"
            name="client-street-address"
            @blur="v$.invoiceForm.clientAddress.street.$touch"
            v-model.trim="invoiceForm.clientAddress.street"
          ></base-input>
        </div>
        <div class="grid grid-city-post-country">
          <div
            :class="{ invalid: v$.invoiceForm.clientAddress.city.$error }"
            class="input-wrapper city"
          >
            <label for="client-city">City</label>
            <base-input
              type="text"
              id="client-city"
              name="client-city"
              @blur="v$.invoiceForm.clientAddress.city.$touch"
              v-model.trim="invoiceForm.clientAddress.city"
            ></base-input>
          </div>
          <div
            :class="{ invalid: v$.invoiceForm.clientAddress.postCode.$error }"
            class="input-wrapper postcode"
          >
            <label for="client-post-code">Post Code</label>
            <base-input
              type="text"
              id="client-post-code"
              name="client-post-code"
              @blur="v$.invoiceForm.clientAddress.postCode.$touch"
              v-model.trim="invoiceForm.clientAddress.postCode"
            ></base-input>
          </div>
          <div
            :class="{ invalid: v$.invoiceForm.clientAddress.country.$error }"
            class="input-wrapper country"
          >
            <label for="client-country">Country</label>
            <base-input
              type="text"
              id="client-country"
              name="client-country"
              @blur="v$.invoiceForm.clientAddress.country.$touch"
              v-model.trim="invoiceForm.clientAddress.country"
            ></base-input>
          </div>
        </div>

        <div class="flex">
          <div
            :class="{ invalid: v$.invoiceForm.createdAt.$error }"
            class="input-wrapper"
          >
            <label for="invoice-date">Invoice Date</label>
            <base-input
              type="date"
              id="invoice-date"
              name="invoice-date"
              @blur="v$.invoiceForm.createdAt.$touch"
              v-model.trim="invoiceForm.createdAt"
            ></base-input>
          </div>
          <div
            :class="{ invalid: v$.invoiceForm.paymentTerms.$error }"
            class="input-wrapper"
          >
            <label for="payment-terms">Payment Terms</label>
            <base-input type="select" v-model.trim="invoiceForm.paymentTerms">
              <option value="1">Net 1 Day</option>
              <option value="7">Net 7 Day</option>
              <option value="14">Net 14 Day</option>
              <option value="30">Net 30 Day</option>
            </base-input>
          </div>
        </div>
        <div
          :class="{ invalid: v$.invoiceForm.description.$error }"
          class="input-wrapper"
        >
          <label for="description">Description</label>
          <base-input
            type="text"
            id="description"
            name="description"
            placeholder="e.g. Graphic Design Service"
            @blur="v$.invoiceForm.description.$touch"
            v-model.trim="invoiceForm.description"
          ></base-input>
        </div>
      </fieldset>
      <fieldset :class="{ invalid: v$.invoiceForm.items.$error }" class="grid">
        <legend>ItemList</legend>
        <invoice-item-form
          v-for="item in invoiceForm.items"
          :key="item.id"
          :id="item.id"
          :item="item"
          @delete-item="deleteItem"
        ></invoice-item-form>
        <base-button
          @click="addNewItem"
          class="input-wrapper btn-add-item"
          mode="quaternary"
          >+ Add New Item</base-button
        >
        <span v-if="v$.invoiceForm.items.$error"
          >- An item must be added.
        </span>
      </fieldset>
    </div>
    <div v-if="editing" class="flex footer-form-edit">
      <base-button @click="discard" mode="quaternary">Cancel</base-button>
      <base-button @click="submitForm" mode="primary">Save Changes</base-button>
    </div>
    <div v-else class="flex footer-form">
      <base-button @click="discard" mode="quaternary">Discard</base-button>
      <base-button @click="submitForm('draft')" mode="tertiary"
        >Save as Draft</base-button
      >
      <base-button @click="submitForm('pending')" mode="primary"
        >Save & Send</base-button
      >
    </div>
  </form>
</template>

<script>
import { useVuelidate } from "@vuelidate/core";
import { required, email, minLength } from "@vuelidate/validators";
import InvoiceItemForm from "@/components/invoices/InvoiceItemForm.vue";

export default {
  components: {
    InvoiceItemForm,
  },
  setup: () => ({ v$: useVuelidate({ $lazy: true, $autoDirty: true }) }),
  props: {
    invoice: {
      type: Object,
      required: false,
      default: null,
    },
  },
  emits: ["save-invoice", "discard"],
  data() {
    return {
      invoiceForm: {
        createdAt: "",
        description: "",
        paymentTerms: "1",
        clientName: "",
        clientEmail: "",
        senderAddress: {
          street: "",
          city: "",
          postCode: "",
          country: "",
        },
        clientAddress: {
          street: "",
          city: "",
          postCode: "",
          country: "",
        },
        items: [],
      },
      editing: false,
    };
  },
  computed: {},
  mounted() {
    if (this.invoice) {
      this.invoiceForm = structuredClone(this.invoice);
      this.editing = true;
    }
  },
  validations() {
    return {
      invoiceForm: {
        createdAt: {
          required,
        },

        description: {
          required,
        },
        paymentTerms: {
          required,
        },
        clientName: {
          required,
        },
        clientEmail: {
          required,
          email,
        },
        senderAddress: {
          street: {
            required,
          },
          city: {
            required,
          },
          postCode: {
            required,
          },
          country: {
            required,
          },
        },
        clientAddress: {
          street: {
            required,
          },
          city: {
            required,
          },
          postCode: {
            required,
          },
          country: {
            required,
          },
        },
        items: {
          required,
          minLength: minLength(1),
        },
      },
    };
  },
  methods: {
    addNewItem() {
      var item = {
        id: Math.random(),
        name: "",
        quantity: "",
        price: "",
        total: 0,
      };
      this.invoiceForm.items.push(item);
    },
    deleteItem(id) {
      const index = this.invoiceForm.items.findIndex((item) => item.id === id);
      this.invoiceForm.items.splice(index, 1);
    },
    discard() {
      this.$emit("discard");
    },
    async submitForm(status) {
      const isFormCorrect = await this.v$.$validate();
      if (!isFormCorrect) return;
      this.invoiceForm.paymentDue = this.getPaymentDue();
      this.invoiceForm.total = this.getTotal();
      if (!this.editing) {
        this.invoiceForm.id = this.generateRandomId();
        this.invoiceForm.status = status;
      }
      this.$emit("save-invoice", this.invoiceForm);
    },
    getPaymentDue() {
      var result = new Date(this.invoiceForm.createdAt);
      result.setDate(result.getDate() + this.invoiceForm.paymentTerms);
      return result.toISOString().split("T")[0];
    },
    getTotal() {
      return this.invoiceForm.items
        .map((item) => item.total)
        .reduce((prev, next) => prev + next);
    },
    generateRandomId() {
      let id = "";
      let letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
      id += letters.charAt(Math.floor(Math.random() * letters.length));
      id += letters.charAt(Math.floor(Math.random() * letters.length));
      id += String(Math.random()).slice(2, 6);
      return id;
    },
  },
};
</script>

<style scoped>
.header-form {
  margin-bottom: 3rem;
  font-weight: var(--fw-700);
  color: hsl(var(--clr-text-heading));
}
form {
  --gap: 0;
  display: grid;
  grid-template-rows: min-content 1fr min-content;
  height: calc(100vh - 5rem);
  width: 100vw;
  max-width: 40rem;
  padding-inline: 2rem;
  padding-top: 2rem;
  border-top-right-radius: 1rem;
  border-bottom-right-radius: 1rem;
}
@media (min-width: 56.25em) {
  form {
    height: 100vh;
  }
}
.fieldset-wrapper {
  overflow-y: auto;
}
fieldset {
  --gap: 1rem;
  border: none;
  margin-block: 1rem;
}
legend {
  color: hsl(var(--clr-primary-100));
  font-weight: var(--fw-700);
}
@media (min-width: 56.25em) {
  .fieldset-wrapper {
    padding-inline: 1.5rem;
  }
}

.footer-form,
.footer-form-edit {
  padding-block: 1.5rem;
}
.footer-form {
  justify-content: space-between;
}
.footer-form-edit {
  margin-left: auto;
  --gap: 0.5rem;
}
@media (min-width: 56.25em) {
  .footer-form {
    --gap: 0.5rem;
  }
  .footer-form > :first-child {
    margin-right: auto;
  }
}

label {
  color: hsl(var(--clr-text-form-label));
}

.city {
  grid-area: city;
}
.postcode {
  grid-area: postcode;
}
.country {
  grid-area: country;
}
.grid-city-post-country {
  grid-template-areas:
    "city    postcode"
    "country country";
}
.grid-item {
  grid-template-columns: 1fr 2fr 1fr max-content;
}
.item-name {
  grid-column: 1/5;
}
@media (min-width: 56.25em) {
  .grid-city-post-country {
    grid-template-areas: "city postcode country";
  }
  .item-name {
    grid-column: 1;
  }
  .grid-item {
    grid-template-columns: 3fr 1fr 2fr 2fr max-content;
  }
}

.delete-item {
  align-self: end;
}
.btn-delete-item {
  margin-left: auto;
}
</style>
<style>
.input-wrapper {
  width: 100%;
}
.input-wrapper > *:where(:not(:first-child)) {
  margin-top: 0.5rem;
}
.invalid label,
.invalid span {
  color: hsl(var(--clr-danger));
}
</style>
